reset;
model;

set I;
set MARKET;

param p{MARKET};
param q;
param r;
param b;
param G;
param t{I,MARKET};

var u0{I} >= 0;
var u1{I,MARKET} >= 0;
var u2{I,MARKET,MARKET} >= 0;
var u3{1..2,MARKET,MARKET,MARKET} >= 0;

maximize Ef: sum{i in MARKET,j in MARKET,k in MARKET}p[i]*p[j]*p[k]*(-r*u3[1,i,j,k] + q*u3[2,i,j,k]);

s.t. st_iniz: sum{i in I}u0[i] = b;

s.t. st_prim{i in MARKET}: sum{j in I}t[j,i]*u0[j] - sum{k in I}u1[k,i] = 0;

s.t. st_seco{i in MARKET,j in MARKET}: sum{k in I}t[k,j]*u1[k,i] - sum{h in I}u2[h,i,j] = 0;

s.t. st_terz{i in MARKET,j in MARKET,k in MARKET}: sum{h in I}t[h,k]*u2[h,i,j] + u3[1,i,j,k] - u3[2,i,j,k] = G;

data;

set I := stock   bond;
set MARKET := up   down;

param b := 55000;
param G := 80000;
param q := 1;
param r := 4;
param p := up 0.5  down 0.5;
param t :  up      down :=
    stock 1.25     1.06
     bond 1.14     1.12;

solve;
display u0,u1,u2,u3;

